; #########################################################################

      .386
      .model flat, stdcall
      option casemap :none   ; case sensitive

; #########################################################################

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

; #########################################################################

        ;=============
        ; Local macros
        ;=============
  
        szText MACRO Name, Text:VARARG
          LOCAL lbl
            jmp lbl
              Name db Text,0
            lbl:
          ENDM
          
        ;=================
        ; Local prototypes
        ;=================
        DlgProc    PROTO :DWORD,:DWORD,:DWORD,:DWORD
        wsprintfA  PROTO C :DWORD,:VARARG
        
    .data
        dlgname       db "DLG0",0
        hInstance     dd 0
        hProcess      dd 0
        hIcon         dd 0
        szBlank       db "                                   ",0
        szPerDone     db "999",0    ;8250  "1275",0
        szSecOut      db "212",0    ;275 486
        szPerOut      db " 25",0    ;44  54
        PerDone       dd 0
        SecOut        dd 275
        PerOut        dd 44
        TotDay        dd 0
        TotHr         dd 0
        TotMin        dd 0
        TotSec        dd 0
        DoneDay       dd 0
        DoneHr        dd 0
        DoneMin       dd 0
        answer        dd 0
        boolTranST1   dd 0
        boolTranST2   dd 0
        boolTranST3   dd 0
        HrFactor      dd 3600
        MinFactor     dd 60       

        fmtStringHr   db " Hours     %lu",0
        fmtStringMn   db " Minutes   %lu",0
        fmtStringAM   db "%2lu:%02lu  AM",0
        fmtStringPM   db "%2lu:%02lu  PM",0
        fmtStringD    db "in %2lu days",0
        fmtStringT    db "%4lu TimeLeft",0

        szBuffer      db "                      ",0
        szBlankDone   db "         ",0
        szTimeDone    db "         ",0
        szDayDone     db "         ",0
        szTommorow    db " tommorow",0


        szTitle       db "               ",0
        szErrMsg32    db "ERROR: Seconds per Screen Update",0
        szErrMsg33    db "ERROR: Percent per Screen Update",0
        szErrMsg4     db "        -MUST- be greater than 0 ",0
        sysTime     SYSTEMTIME  <>        
                 
    .const
        IDC_BUTTON0  equ    3000
        IDC_BUTTON1  equ    3001

        IDC_EDIT00   equ    3100h
        IDC_EDIT01   equ    3101h
        IDC_EDIT02   equ    3102h
        IDC_EDIT03   equ    3103h
        IDC_EDIT04   equ    3104h
        IDC_EDIT05   equ    3105h
        IDC_EDIT06   equ    3106h
        IDC_EDIT07   equ    3107h
        IDC_EDIT08   equ    3108h
        IDC_EDIT09   equ    3109h
        IDC_EDIT0A   equ    310Ah
        IDC_EDIT0B   equ    310Bh
        IDC_EDIT0C   equ    310Ch
        IDC_EDIT0D   equ    310Dh
        IDC_EDIT0E   equ    310Eh
        IDC_EDIT0F   equ    310Fh

        IDC_EDIT14   equ    3114h
        IDC_EDIT24   equ    3124h
        IDC_EDIT34   equ    3134h
        IDC_EDIT44   equ    3144h
        IDC_EDIT54   equ    3154h
        IDC_EDIT64   equ    3164h
        IDC_EDIT74   equ    3174h
        IDC_EDIT84   equ    3184h
        IDC_EDIT94   equ    3194h
        IDC_EDITA4   equ    31A4h
        IDC_EDITB4   equ    31B4h
        IDC_EDITC4   equ    31C4h
        IDC_EDITD4   equ    31D4h
        IDC_EDITE4   equ    31E4h
        IDC_EDITF4   equ    31F4h


        IDC_TEXT3    equ    3303
        IDC_TEXT4    equ    3304

        IDC_TEXT7    equ    3307
        IDC_TEXT8    equ    3308

    .code

start:

; #########################################################################

        invoke GetModuleHandle, NULL
        mov    hInstance, eax

        invoke GetCurrentProcess
        mov    hProcess, eax
        invoke SetPriorityClass, hProcess, IDLE_PRIORITY_CLASS
        
        ; -------------------------------------------
        ; Call the dialog box stored in resource file
        ; -------------------------------------------
        invoke DialogBoxParam,hInstance,ADDR dlgname,0,ADDR DlgProc,NULL

        invoke ExitProcess,eax

; #########################################################################

DlgProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      .if uMsg == WM_INITDIALOG
         invoke SetDlgItemText,hWin,IDC_EDIT04,ADDR szPerDone
         invoke SetDlgItemText,hWin,IDC_EDIT14,ADDR szSecOut
         invoke SetDlgItemText,hWin,IDC_EDIT24,ADDR szPerOut

         invoke SetDlgItemText,hWin,IDC_TEXT3,ADDR szBlank
         invoke SetDlgItemText,hWin,IDC_TEXT4,ADDR szBlank

         invoke LoadIcon,hInstance,200
         mov hIcon, eax
         invoke SendMessage,hWin,WM_SETICON,1,hIcon

      .elseif uMsg==WM_COMMAND
        mov  eax,wParam
        mov  edx,eax
        shr  edx,16
 	  .if dx==BN_CLICKED
		.if eax==IDC_BUTTON0     ; the CALC button will CALC and PRINT
                  invoke GetDlgItemInt,hWin,IDC_EDIT04,ADDR boolTranST1,FALSE
                  mov    PerDone, eax
                  invoke GetDlgItemInt,hWin,IDC_EDIT14,ADDR boolTranST2,FALSE
                  mov    SecOut, eax
                  invoke GetDlgItemInt,hWin,IDC_EDIT24,ADDR boolTranST3,FALSE
                  mov    PerOut, eax
                  invoke wsprintf,ADDR szTitle,ADDR fmtStringT,PerDone
			invoke SendMessage,hWin,WM_SETTEXT,0,ADDR szTitle

;                  .if boolTranST3 == FALSE   ; would fix div by zero
;                     mov eax, 1
;                     mov PerOut, eax
;                  .endif

                  mov    eax, 10000       ; 100 - PerDone
                  mov    ecx, PerDone
                  sub    eax, ecx         ; eax <- answer1

                  mov    ecx, SecOut      ; ecx <- SecOut
                  mul    ecx              ; answer1 * SecOut   edx:eax <- answer2

                  mov    ecx, PerOut      
                  .if ecx != 0
                     mov    edx, 0
                     div    ecx           ; answer2 / PerOut   
                     mov    TotSec, eax   ; TotSec <- eax <- answer

                     .if  eax>=3600
                        mov    ecx, HrFactor      ; HrFactor = 3600 
                        mov    edx, 0
                        div    ecx                ; div    HrFactor
                        mov    TotHr, eax
                     .else
                        mov    eax, 0
                        mov    TotHr, eax
                     .endif
    
                     invoke wsprintf,ADDR szBuffer,ADDR fmtStringHr,TotHr
                     invoke SetDlgItemText,hWin,IDC_TEXT3,ADDR szBuffer     ; display hours left
    
                     mov    eax, TotHr
                     mov    ecx, HrFactor      ; 3600
                     mul    ecx                ; ecx * eax -> edx:eax
                     mov    ecx, eax           ;              edx gets hi 32 bits 
    
                     mov    eax, TotSec
                     .if eax>=60
                        sub    eax, ecx
                        mov    ecx, MinFactor   ; MinFactor = 60
                        mov    edx, 0
                        div    ecx              ; edx:eax / ecx -> ANS=eax, REMAIN=edx
                        mov    TotMin, eax
                     .else
                        mov    eax, 0
                        mov    TotMin, eax
                     .endif   
    
                     invoke wsprintf,ADDR szBuffer,ADDR fmtStringMn,TotMin
                     invoke SetDlgItemText,hWin,IDC_TEXT4,ADDR szBuffer      ; display minutes part  left

                     mov eax, TotHr             ; DoneHr  := TotHr
                     mov DoneHr, eax
                     mov eax, TotMin            ; DoneMin := TotMin
                     mov DoneMin, eax

                     invoke  GetLocalTime, offset sysTime
                     mov  eax, 0
                     mov  ax, sysTime.wHour
                     mov  DoneHr, eax           ; DoneHr  := sysTime.wHour  ( 24 hour clock ?? )
                     mov  eax, 0
                     mov  ax, sysTime.wMinute
                     mov  DoneMin, eax          ; DoneMin := sysTime.wMinute

                     mov  eax, DoneHr
                     mov  ecx, TotHr
                     add  eax, ecx
                     mov  DoneHr, eax           ; DoneHr  := DoneHr  + TotHr

                     mov  eax, DoneMin
                     mov  ecx, TotMin
                     add  eax, ecx
                     mov  DoneMin, eax          ; DoneMin := DoneMin + TotMin

                     .if ( DoneMin >= 60 )      ; adjust  Minutes to be  0..59
                        inc DoneHr
                        sub DoneMin, 60
                     .endif

;                     mov  eax, 0
                     
                     mov  DoneDay, 0
                     .while (DoneHr >= 24)
                        inc DoneDay
                        sub DoneHr, 24
                     .endw

                     .if (DoneHr <= 11)
                       .if (DoneHr == 0)
                          mov DoneHr, 12
                       .endif
                       invoke wsprintf,ADDR szTimeDone,ADDR fmtStringAM,DoneHr,DoneMin
                     .else
                       .if (DoneHr > 12)
                          sub DoneHr, 12
                       .endif
                       invoke wsprintf,ADDR szTimeDone,ADDR fmtStringPM,DoneHr,DoneMin
                     .endif
                     invoke SetDlgItemText,hWin,IDC_TEXT7,ADDR szTimeDone
                     invoke SetDlgItemText,hWin,IDC_EDIT0D,ADDR szPerDone
                     
                     invoke SetDlgItemText,hWin,IDC_TEXT8,ADDR szBlankDone
                     .if (DoneDay == 1)
                        invoke SetDlgItemText,hWin,IDC_TEXT8,ADDR szTommorow
                     .elseif (DoneDay > 1)
                        invoke wsprintf,ADDR szDayDone,ADDR fmtStringD, DoneDay
                        invoke SetDlgItemText,hWin,IDC_TEXT8,ADDR szDayDone
                     .endif


                  .elseif boolTranST2 == FALSE 
                     invoke SetDlgItemText,hWin,IDC_TEXT3,ADDR szErrMsg32
                     invoke SetDlgItemText,hWin,IDC_TEXT4,ADDR szErrMsg4
                  .else
                     invoke SetDlgItemText,hWin,IDC_TEXT3,ADDR szErrMsg33
                     invoke SetDlgItemText,hWin,IDC_TEXT4,ADDR szErrMsg4
                  .endif   

		.elseif eax==IDC_BUTTON1     ; the EXIT button will be an EXIT
			invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
		.endif
        .endif

      .elseif uMsg == WM_CLOSE
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax
    ret

DlgProc endp

; ########################################################################


end start
